math.randomseed(os.time())
math.randomseed(os.time())
math.random(1,10)

local text = ""
local persisting = 0

game = {}

game.debug_text = {}
game.debug_timer = 5

game.fullscreen = false
game.default_window_width = 480
game.default_window_height = 270
game.width  = love.graphics.getWidth()
game.height = love.graphics.getHeight()
game.scalex = game.width/game.default_window_width
game.scaley = game.height/game.default_window_height
love.window.setMode( game.width, game.height, {resizable = true, minwidth = game.default_window_width, minheight = game.default_window_height })
game.font = love.graphics.newFont(5.5*game.scaley/love.window.getPixelScale())
game.font:setFilter("nearest","nearest",0,0)
game.keys = {}

game.ps = {}
game.gfx = {}

game.sfx = {}

function game.add_debug_mesage(text, color)
   game.debug_text[tostring(text)]={timer=game.debug_timer, color = color}
end

function game.add_debug_update(dt)
   for k,v in pairs (game.debug_text) do
       game.debug_text[k].timer=game.debug_text[k].timer - dt
	   if game.debug_text[k].timer < 0 then game.debug_text[k] = nil end
   end
end

function game.play_sound(sound, volume, position)
end


local x,y = love.window.getPosition()
x = x +200 y = y -100
love.window.setMode(game.width, game.height, {resizable=true, x=x, y=y, minwidth = game.default_window_width, minheight = game.default_window_height })
x,y = nil,nil


game.anim8       = require 'lib.anim8'
game.bump        = require 'lib.bump'
game.shine       = require "lib.shine"
game.players     = require 'players'

game.sti         = require "lib/sti"


game.players:set_game(game)


game.deepcopy = deepcopy
game.after = after



game.map = game.sti.new("levels/intro.lvl", {"bump"})
for k,v in ipairs(game.map.layers) do
    game.map.layers[k].y = game.map.layers[k].offsety+3
end

game.ps.world = game.bump.newWorld(16)
game.map:bump_init(game.ps.world)


local player = game.players:add("4aiman", {x=32, y=32})

game.map.chests = {}
for _,obj in pairs(game.map.layers.chests.objects) do
   if     obj.type == "chest_opened" then
		  obj.tile = game.gfx.chest_opened
   elseif obj.type == "chest_closed" then
          obj.tile = game.gfx.chest_closed
   end

   local dummy = obj
   dummy.sfx = {open= game.sfx.chest_opened}
   dummy.gravity = 9.8
   dummy.obj = obj
   dummy.is_chest = true
   dummy.opened_tile = game.gfx.chest_opened
   game.ps.world:add(dummy, dummy.x, dummy.y, dummy.width, dummy.height)   
   game.map.chests[obj.x.." "..obj.y] = dummy
end

game.map.destructible = {}
for idx,obj in pairs(game.map.layers.destructible.objects) do

   local dummy = obj
  
   dummy.tile = game.gfx.destructible
   dummy.tile_top = game.gfx.destructible_top
   obj.properties.solid = "full"
   for k,v in pairs(obj.properties) do
       obj[k] = v
   end
   dummy.y = dummy.y-32
   dummy.dead = false
   dummy.destructible = math.random(1,5)
   dummy.max_destructible = dummy.destructible + 0 
   game.ps.world:add(dummy, dummy.x, dummy.y, dummy.width, dummy.height)
   game.map.destructible[idx] = dummy
end



destructible = {}
function destructible.filter(dest, other)
   if other.is_sensor then return false end
   if other.destructible and dest.y>other.y-3 then return false end
   return "slide"
end


function love.load()
  love.filesystem.setIdentity(love.filesystem.getIdentity(),true)
  love.filesystem.setIdentity('Sky goes to Net');
  canvas = love.graphics.newCanvas()  
  game.canvas = canvas  
  canvas:setFilter("nearest","nearest",0,0)
end


local layers_order={"parallax2", "parallax1", "background","floors","floors2","walls2","deco_bg","hazzards", "obj2","deco_fg","walls"}


local cycle = 0

local wanted_fps = 400
local current_time = 0
local gdt = 0

function love.update(dt)
   gdt = dt
  
   
   current_time = current_time + dt
   if current_time < 1/wanted_fps then
      return
   end
      
   game.fps = 1/current_time
   current_time = 0

   
   if game.intro_running then       
      intro:update(dt)
      return 
   end
   

   if game.keys["3"] then
      game.stop = false
	  return
   end

 


 cycle = cycle + 1
 
game.map:update(dt)
 
  function chest_filter(chest,other)
     if other.is_sensor then return false end
     if other.is_enemy then return false end
     if other.virtual then return false end

     if other.properties then
	    if other.properties.solid then return "touch" end
	    if other.properties.deco  then return false end	    	    
     end
	 
	 if other.type then
	    if other.type:find("chest") then return false end	    
	 end
	 
	 if other.is_player then return false end	 
	 if other.projectile then return false end

     return "touch"
  end	 
	   for obj, val in pairs(game.map.chests) do
	       if val then
		      local vx, vy = val.velx or 0, val.vely or 0
			  local cols, len
		      vy = vy + val.gravity*2
			  val.vely = vy
			  val.velx = vx			  
              val.y = val.y + vy*dt
	          val.x, val.y, cols, len = game.ps.world:move(val, val.x, val.y, chest_filter)
			  for i,v in ipairs(cols) do
			     if cols[i].normal.y == -1 then
				    
					game.map.chests[obj].vely = 0
				 end 
			  end
			  val.obj.x = val.x
			  val.obj.y = val.y
			  
		   end
	   end


	   for idx, dest in pairs(game.map.destructible) do
	       if dest then
		      if dest.dead then
			     game.ps.world:remove(dest)
				 game.map.destructible[idx] = nil
				 dest = nil
				 idx = nil
			  end
		   end
		end 

	   for idx, dest in pairs(game.map.destructible) do
		   if dest then	
				 if dest.gravity then				    
					local vx, vy = dest.velx or 0, dest.vely or 0
					local cols, len
					vy = vy + dest.gravity*2
					dest.vely = vy
					dest.velx = vx			  
					dest.y = dest.y + vy*dt
					dest.x, dest.y, cols, len = game.ps.world:move(dest, dest.x, dest.y, destructible.filter)
					for i,v in ipairs(cols) do
					   if cols[i].normal.y == -1 then
						  game.map.destructible[idx].vely = 0
					   end 
					end
				 end
		   else
		   end
	   end



       
	  for i=1,#layers_order do
	      if game.map.layers[layers_order[i]].properties.zindex<game.map.layers.walls.properties.zindex then
   	         game.map.layers[layers_order[i]].x = player.x*i*0.3
   	         game.map.layers[layers_order[i]].y = player.y*i*0.2
		  end
	  end


   game.players:update(dt)
   
   

end

function love.draw(dt)

   love.graphics.clear( )
   love.graphics.setFont(game.font)
   local ww, wh = love.window.getMode()
   if game.intro_running then 
      intro:draw(game.width,game.height)
      local ma, mi, re, co = love.getVersion()
      love.graphics.print("Copyright 4aiman, 2016. Powered by Love2d \""..co.." "..ma.."."..mi.."."..re.."\". ".._VERSION .." inside." ,10*game.scaley,wh-10*game.scaley)

      return 
   end

   
   local offset = 0   
   love.graphics.setCanvas(canvas)
   love.graphics.clear( )
   love.graphics.push()
   

      local plx = player.x
      local ply = player.y

      local tx = math.floor( -plx + game.default_window_width / 2 )
      local ty = math.floor( -ply + game.default_window_height / 2 )
      love.graphics.translate(tx, ty)


  

	  for i=1,#layers_order do
		  if game.map.layers[layers_order[i]].properties.zindex<game.map.layers.walls.properties.zindex then		     
             love.graphics.setColor(50, 10, 10, 150)
	         
          elseif layers_order[i] == 'background' then
			  
			  love.graphics.setColor(255,255,255)
		  else
			  love.graphics.setColor(255,255,255)
		  end

   	      game.map.layers[layers_order[i]]:draw()
		  if layers_order[i] == 'obj2' then
	 	    for obj, val in pairs(game.map.destructible) do 
			    if val then			  
				   if val.visible then
				      local step = 200/val.max_destructible 
					  local r = 255 - step*(val.destructible-1) 
					  local g = step*val.destructible 
					  local b = (val.destructible/val.max_destructible)*step
					  love.graphics.setColor(r,g,0)

					  local covered
					  for obj2,val2 in pairs(game.map.destructible) do
						  if val2 and val2.visible then
						     if val.x == val2.x and val.y==val2.y+val2.height then 
							    
							    covered = true
							    break
						     end
						  end
					  end

					  if not covered then
					     love.graphics.draw(val.tile_top, val.x, val.y-5)
					  end				 
					  love.graphics.draw(val.tile, val.x, val.y+3)
					  if not covered then
					     
					  end				 
					
				   end			  
			    end		   
		    end

		    love.graphics.setColor(255, 255, 255, 255)

		    for obj, val in pairs(game.map.chests) do
			    love.graphics.draw(val.tile, val.x, val.y) 
		    end

  	        
		
			local offset = 0
			for pll, player in pairs(game.player_list) do	      
				if not game.player_list[pll].fore then
				   game.players:draw_player(pll, tx+offset*0+8,ty+offset*90+8)
				end
				offset = offset+1
			end
         end
	  end
	  

	   
   love.graphics.setColor(255, 255, 255)   

	  local yoff = 30
	  for k,v in pairs(game.debug_text) do	      
	      if v.color then
		     love.graphics.setColor(game.debug_text[k].color[1], game.debug_text[k].color[2], game.debug_text[k].color[3], game.debug_text[k].color[4] or 100)			 
		  end
	      love.graphics.print(k, -tx+8, -ty+yoff)
		  love.graphics.setColor(255,255,255)
		  local _, col = k:gsub("\n"," ")
		  if not col then col = 0 end
		  col = col+1
		  yoff = yoff + col *10
	  end




	  love.graphics.setColor(0, 0, 0, 055)
	  love.graphics.rectangle("line", -tx+4 ,-ty+4, game.default_window_width-8,game.default_window_height-8)
	  love.graphics.setColor(0, 0, 0, 055)
	  love.graphics.rectangle("line", -tx+3 ,-ty+3, game.default_window_width-6,game.default_window_height-6)
	  love.graphics.setColor(0, 0, 0, 105)
	  love.graphics.rectangle("line", -tx+2 ,-ty+2, game.default_window_width-4,game.default_window_height-4)
	  love.graphics.setColor(0, 0, 0, 205)
	  love.graphics.rectangle("line", -tx+1 ,-ty+1, game.default_window_width-2,game.default_window_height-2)
	  love.graphics.setColor(0, 0, 0, 255)
	  love.graphics.rectangle("line", -tx ,-ty, game.default_window_width, game.default_window_height)

	  love.graphics.setColor(0, 0, 0, 255)
	  love.graphics.rectangle("fill", -tx-5000 ,-ty, 5000,game.default_window_height)
	  love.graphics.rectangle("fill", -tx+game.default_window_width ,-ty,  5000, 5000)
	  love.graphics.rectangle("fill", -tx-5000 ,-ty+game.default_window_height,  50000, 5000)
	  

	  love.graphics.setColor(255, 255, 255, 255)

	  if game.map.layers.cover then 
	     game.map.layers.cover:draw()
	  end

   

	  local cnt = 0
	  for k, v in pairs(player.powerups) do
	      cnt = cnt+1
	      love.graphics.print(k.." "..v, -tx+220 ,-ty+5+cnt*10)
	  end


	  local offset = 0
	  for pll, player in pairs(game.player_list) do
 		  if game.player_list[pll].fore then
			 game.players:draw_player(pll, tx+offset*0+8,ty+offset*90+8)
		  end

		local draw_controls = true
		   

		  offset = offset+1
	  end   
   love.graphics.setColor(255, 255, 255)
  
   local items, ln = game.ps.world:getItems()
   for k, v in pairs(items) do
       local x,y,w,h = game.ps.world:getRect(v)	   
       love.graphics.rectangle("line", x, y, w, h)
   end   

   love.graphics.pop()

   love.graphics.setColor(255, 255, 255)

   love.graphics.setCanvas()


      offset = ((ww/game.scaley - game.default_window_width)/2)*game.scaley
      love.graphics.draw(canvas, offset,0, 0, game.scaley)

   love.graphics.push()
   love.graphics.scale(game.scaley)
      

   love.graphics.pop()

         local ma, mi, re, co = love.getVersion()
         love.graphics.print("Copyright 4aiman, 2016. Powered by Love2d \""..co.." "..ma.."."..mi.."."..re.."\". ".._VERSION .." inside." ,10*game.scaley,wh-10*game.scaley)


    love.graphics.push()

    love.graphics.pop()

  
end


function love.keypressed(key, unicode)
   game.keys[key] = true   
   game.keys[unicode] = true
   if game.keys["f12"] then
      local screenshot = love.graphics.newScreenshot();	  
	  local filename = os.date("%A %B %Y @ %H_%M_%S") .. '.png'
	  love.system.setClipboardText(filename)
	  game.add_debug_mesage("Screenshot saved to "..filename)
      screenshot:encode('png', filename);
   end
end

function love.keyreleased(key, scancode)
   if game.keys["f11"] then      	  
	  if not game.fullscreen then 
         game.old_width  = game.width
         game.old_height = game.height
		 game.old_pos = {}
		 game.old_pos.x, game.old_pos.y = love.window.getPosition()
		 local _, _, flags = love.window.getMode()
         local width, height = love.window.getDesktopDimensions(flags.display)
		 game.width = width
         game.height = height
	  else
         game.width = game.old_width
         game.height = game.old_height
		 love.window.setMode(game.width, game.height, {resizable = true, minwidth = game.default_window_width, minheight = game.default_window_height  })
		 love.window.setPosition(game.old_pos.x, game.old_pos.y)
		 love.resize(game.width, game.height)
	  end
	  game.fullscreen = not not not game.fullscreen
	  love.window.setFullscreen(game.fullscreen)
   end
   game.keys[key] = false
   game.keys[scancode] = false
end

function love.resize(w, h)   
   if w+10 <= ((16*h)/9)-100*game.scaley then 
      game.scalex = game.width/game.default_window_width
      game.scaley = game.scalex
   else      
      game.scaley = game.height/game.default_window_height
      game.scalex = game.scaley

   end
   game.width  = w
   game.height = h
   for pll, player in pairs(game.player_list) do   
       player.controls.offset = (w/game.scaley - game.default_window_width)/2
   end
   blur = nil 
   scanlines = nil
   blur = game.shine.crt()
   scanlines = game.shine.scanlines()
   
end

